Index: /palm/trunk/SCRIPTS/inifor_script
===================================================================
--- /palm/trunk/SCRIPTS/inifor_script	(revision 3790)
+++ /palm/trunk/SCRIPTS/inifor_script	(revision 3791)
@@ -1,5 +1,5 @@
 #!/bin/bash
 
-# palmrun - script for running PALM jobs
+# inifor - The Mesoscale Interface for Initializing and Forcing PALM
 
 #--------------------------------------------------------------------------------#
@@ -29,5 +29,5 @@
 # 
 #--------------------------------------------------------------------------------#
-# inifor - script for running inifor
+# inifor - script for running the inifor executable
 #--------------------------------------------------------------------------------#
 
@@ -41,85 +41,15 @@
  set +o noclobber    # EXISTING FILES ARE ALLOWED TO BE OVERWRITTEN
 
- typeset -i  ibd=0 ibdt=0 iec=0 iic=0 iin=0 ioc=0 iout=0 nr_of_input_files=0
- typeset -i  nr_of_output_files=0
- typeset -x -i  memory=0   # HAS TO BE EXPORTED HERE, OTHERWISE AN UNKNOWN SIDE
-                           # SIDE EFFECT MAY CAUSE DATA LOSS WHEN GETOPTS IS READING THE
-                           # SCRIPT-OPTION ARGUMENTS
- typeset -i  cores cputime cpu_hours cpu_minutes cpu_seconds i ii iia iii iio
- typeset -i  icycle inode ival maxcycle mpi_tasks
- typeset -i  nodes remaining_cores run_number tasks_per_node threads_per_task
-
- activation_string_list=""
- AddFilenames=""
- combine_plot_fields=true
- compiler_name=""
- compiler_name_ser=""
- compiler_options=""
+ typeset -i  i iec=0
+
+ activation_string_list="inifor"
  configuration_identifier="default"
- cores=1
- cores_atmos=0
- cores_ocean=0
- coupled_dist=""
- cpp_options=""
- cpumax=0
- create_batch_job=false
- create_jobfile_only=false
- create_remote_batch_job=false
- dashes="  ----------------------------------------------------------------------------"
- defaultqueue=""
  delete_temporary_catalog=true
- do_compile=true
- do_trace=false
- executable=""
- execute_command=""
- execution_error=false
  fileconnection_file=trunk/SCRIPTS/.palm.iofiles
- global_revision=""
- hostfile=""
- hp=""
- keep_data_from_previous_run=false
- link_local_input=false
- link_local_output=false
- linker_options=""
- local_jobcatalog=""
  locat=normal
- makefile=""
- max_par_io_str=""
- prc=$0
- while [[ $(echo $prc | grep -c "/") != 0 ]]
- do
-    prc=`echo $prc | cut -f2- -d"/"`
- done
- module_calls=""
- palmrun_memory=""
- palmrun_script_name=$prc
- openmp=false
- previous_job=""
- project_account=""
- queue=none
- read_svf=""
- restart_run=false
- return_address=""
- remote_jobcatalog=""
- remote_username=""
- running_in_batch_mode=false
- running_in_test_mode=false
- run_coupled_model=false
- run_id=""
- run_id_number=""
  run_identifier=test
  silent=false
- source_list=""
- source_path=""
- tasks_per_node=0
- threads_per_task=1
- transfer_problems=false
- user_source_path=""
- use_existing_sources_folder=""
- use_openmp=false
- version="palmrun  1.0 Rev$Rev: 3725 $"
+ version="inifor  0.1 Rev$Rev$"
  working_directory=`pwd`
- write_binary=""
- write_svf=""
 
 
@@ -138,13 +68,13 @@
           done
           [[ $delete_temporary_catalog = true ]]  &&  (cd; rm -rf $tempdir)
-          printf "\n\n+++ palmrun crashed \n\n"
+          printf "\n\n+++ inifor crashed \n\n"
           exit 1
        elif [[ $locat != normal ]]
        then
           [[ $delete_temporary_catalog = true ]]  &&  (cd; rm -rf $tempdir)
-          printf "\n+++ palmrun killed by \"^C\" \n\n"
+          printf "\n+++ inifor killed by \"^C\" \n\n"
           exit 2
        else
-          printf "\n --> palmrun finished\n\n"
+          printf "\n --> inifor finished\n\n"
           exit 0
        fi' exit
@@ -157,41 +87,14 @@
 
 
-    # READ SHELLSCRIPT-OPTIONS AND REBUILD THE PALMRUN-COMMAND STRING (prc),
-    # WHICH WILL BE USED TO START RESTART-JOBS
- while  getopts  :a:A:bBc:CFG:i:jkm:M:O:q:r:R:s:t:T:u:U:vVw:W:xX:yY:zZ option
+    # READ SHELLSCRIPT-OPTIONS
+    # TODO: add additional inifor options
+ while  getopts  :a:Bc:r:v  option
  do
    case  $option  in
-       (a)   activation_string_list=$OPTARG; prc="$prc -a'$OPTARG'";;
-       (A)   project_account=$OPTARG; prc="$prc -A'$OPTARG'";;
-       (b)   create_batch_job=true; prc="$prc -b";;
-       (B)   delete_temporary_catalog=false; prc="$prc -B";;
-       (c)   configuration_identifier=$OPTARG; prc="$prc -c$OPTARG";;
-       (C)   restart_run=true; prc="$prc -C";;
-       (F)   create_jobfile_only=true;;
-       (G)   global_revision=$OPTARG; prc="$prc -G'$OPTARG'";;
-       (i)   run_id_number=$OPTARG;;
-       (j)   running_in_batch_mode=true;;
-       (k)   keep_data_from_previous_run=true; prc="$prc -k";;
-       (m)   palmrun_memory=$OPTARG; prc="$prc -m$OPTARG";;
-       (M)   makefile=$OPTARG; prc="$prc -M$OPTARG";;
-       (O)   use_openmp=true; threads_per_task=$OPTARG; prc="$prc -O$OPTARG";;
-       (q)   queue=$OPTARG; prc="$prc -q$OPTARG";;
-       (r)   run_identifier=$OPTARG; prc="$prc -r$OPTARG";;
-       (R)   return_address=$OPTARG;;
-       (s)   source_list=$OPTARG;;
-       (t)   palmrun_cpumax=$OPTARG; prc="$prc -t$OPTARG";;
-       (T)   palmrun_tasks_per_node=$OPTARG; prc="$prc -T$OPTARG";;
-       (u)   remote_username=$OPTARG; prc="$prc -u$OPTARG";;
-       (U)   return_username=$OPTARG; prc="$prc -U$OPTARG";;
-       (v)   silent=true; prc="$prc -v";;
-       (V)   use_existing_sources_folder="-V";;
-       (w)   max_par_io_str=$OPTARG; prc="$prc -w$OPTARG";;
-       (W)   previous_job=$OPTARG;;
-       (x)   do_trace=true;set -x; prc="$prc -x";;
-       (X)   palmrun_cores=$OPTARG; prc="$prc -X$OPTARG";;
-       (y)   ocean_file_appendix=true; prc="$prc -y";;
-       (Y)   run_coupled_model=true; coupled_dist=$OPTARG; prc="$prc -Y'$OPTARG'";;
-       (z)   running_in_test_mode=true;;
-       (Z)   combine_plot_fields=false; prc="$prc -Z";;
+       (a)   activation_string_list=$OPTARG;;
+       (B)   delete_temporary_catalog=false;;
+       (c)   configuration_identifier=$OPTARG;;
+       (r)   run_identifier=$OPTARG;;
+       (v)   silent=true;;
        (\?)  printf "\n  +++ unknown option $OPTARG \n"
              printf "\n  --> type \"$0 ?\" for available options \n"
@@ -207,4 +110,5 @@
 
     # PRINT SHORT DESCRIPTION OF PALMRUN OPTIONS
+    # TODO: add description of additional inifor options
  if [[ "$1" = "?" ]]
  then
@@ -212,35 +116,7 @@
     printf "\n      Option  Description                              Default-Value"
     printf "\n        -a    activation string list                   \"\" "
-    printf "\n        -A    project account number                   ---"
-    printf "\n        -b    batch-job on local machine               ---"
-    printf "\n        -B    do not delete temporary directory at end ---"
     printf "\n        -c    configuration identifier                 \"default\" "
-    printf "\n        -F    create batch job file only               ---"
-    printf "\n        -k    keep data from previous run"
-    printf "\n        -m    memory demand in MB (batch-jobs)         0 MB"
-    printf "\n        -M    Makefile name                            Makefile"
-    printf "\n        -O    threads per openMP task                  ---"
-    printf "\n        -q    queue                                    \"$queue\" "
     printf "\n        -r    run identifier                           test"
-    printf "\n        -s    filenames of routines to be compiled     \"\" "
-    printf "\n              must end with .f, .f90, .F, or .c !"
-    printf "\n              use \"..\" for more than one file and wildcards"
-    printf "\n              -s LM compiles all locally modified files"
-    printf "\n        -t    allowed cpu-time in seconds (batch)      0"
-    printf "\n        -T    tasks per node                           ---"
-    printf "\n        -u    username on remote machine               \"\" "
     printf "\n        -v    no prompt for confirmation               ---"
-    printf "\n        -V    check if SOURCES_FOR_RUN_... exists      ---"
-    printf "\n        -w    maximum parallel io streams              as given by -X"
-    printf "\n        -W    name of job to wait for                  ---"
-    printf "\n        -x    tracing of palmrun for debug purposes    ---"
-    printf "\n        -X    # of processors (on parallel machines)   1"
-    printf "\n        -y    add appendix \"_O\" to all local output"
-    printf "\n              files (ocean precursor runs followed by"
-    printf "\n              coupled atmosphere-ocean runs)           ---"
-    printf "\n        -Y    run coupled model, \"#1 #2\" with" 
-    printf "\n              #1 atmosphere and #2 ocean processors    \"#/2 #/2\" depending on -X"
-    printf "\n        -Z    skip combine_plot_fields at the end of      "
-    printf "\n              the simulation                           ---"
     printf "\n "
     printf "\n      Possible values of positional parameter <modus>:"
@@ -268,8 +144,10 @@
  if [[ ! -f $config_file ]]
  then
+
     printf "\n\n  +++ configuration file: "
     printf "\n           $config_file"
     printf "\n      does not exist"
-    locat=connect; exit  
+    locat=connect; exit
+
  fi
 
@@ -280,16 +158,11 @@
 
        # CHECK VERSION MISMATCH
-       # RESTART RUNS DON'T REQUIRE A CHECK, BECAUSE THEY USE A COPY OF THAT
-       # FILE WHICH HAS ALREADY BEEN CHECKED WITHIN THE INITAL PALMRUN CALL
-    if [[ $running_in_batch_mode != true  &&  $restart_run != true ]]
-    then
-       if [[ $(head -n1 $fileconnection_file) != $(head -n1 .palm.iofiles) ]]
-       then
-          printf "\n\n  +++ WARNING: A file connection file has been found in your"
-          printf "\n               working directory, but its revision does not match"
-          printf "\n               the revision of the default (trunk) version."
-          printf "\n               You may need to update your connection file"
-          printf "\n               \"${working_directory}/.palm.iofiles\" !"
-       fi
+    if [[ $(head -n1 $fileconnection_file) != $(head -n1 .palm.iofiles) ]]
+    then
+       printf "\n\n  +++ WARNING: A file connection file has been found in your"
+       printf "\n               working directory, but its revision does not match"
+       printf "\n               the revision of the default (trunk) version."
+       printf "\n               You may need to update your connection file"
+       printf "\n               \"${working_directory}/.palm.iofiles\" !"
     fi
 
@@ -310,4 +183,6 @@
 
     # CHECK, IF THE ACTIVATION_STRING_LIST HAS BEEN GIVEN
+    # TODO: I suggest to use/extend the .palm.iofiles file to set the inifor I/O files,
+    #       activation string could be "inifor"
  if [[ "$activation_string_list" = "" ]]
  then
@@ -318,31 +193,10 @@
 
 
-    # SET VARIABLE TO ACTIVATE PALM BINARY OUTPUT FOR RESTARTS
- if [[ $(echo $activation_string_list | grep -c "restart") != 0 ]]
- then
-    write_binary=true
- else
-    write_binary=false
- fi
-
-    # SET VARIABLE TO ACTIVATE WRITING OF SVF DATA
- if [[ $(echo $activation_string_list | grep -c "svfout") != 0 ]]
- then
-    write_svf=true
- else
-    write_svf=false
- fi
-
-    # SET VARIABLE TO ACTIVATE READING OF SVF DATA 
- if [[ $(echo $activation_string_list | grep -c "svfin") != 0 ]]
- then
-    read_svf=true
- else
-    read_svf=false
- fi
-
-
     # READ AND EVALUATE THE CONFIGURATION-FILE
+    # TODO: we can think about if it is really required tio read and interpret the whole file
+    #       since many settings are not relevant for inifor. Instead, we could read only lines
+    #       inifor-specific variables are set (like it is done in palmbuild)
  [[ $silent = false ]]  &&  printf "\n\n    Reading the configuration file... "
+
 
     # READ VARIABLE SETTINGS FROM CONFIG FILE LINE BY LINE
@@ -444,80 +298,25 @@
 
     # CHECK SETTING OF REQUIRED PARAMETERS
- if [[ "$fast_io_catalog" = "" ]]
- then
-    printf "\n  +++ no fast_io_catalog found in $config_file"
-    printf "\n      Please add line \"fast_io_catalog ...\" to that file."
+    # TODO: we probably need to include such a line in the configuration file
+ if [[ "$execute_command_inifor" = "" ]]
+ then
+    printf "\n  +++ no execute command found for inifor in $config_file"
+    printf "\n      Please add line \"execute_command_inifor ...\" to that file."
     locat=config_file; exit
  fi
- if [[ "$compiler_name" = "" ]]
- then
-    printf "\n  +++ no compiler name found in $config_file"
-    printf "\n      Please add line \"compiler_name ...\" to that file."
-    locat=config_file; exit
- fi
- if [[ "$compiler_name_ser" = "" ]]
- then
-    printf "\n  +++ no compiler name for non-paralle compilation found in $config_file"
-    printf "\n      Please add line \"compiler_name_ser ...\" to that file."
-    locat=config_file; exit
- fi
- if [[ "$compiler_options" = "" ]]
- then
-    printf "\n  +++ no compiler options found in $config_file"
-    printf "\n      Please add line \"compiler_options ...\" to that file."
-    locat=config_file; exit
- fi
- if [[ "$execute_command" = "" ]]
- then
-    printf "\n  +++ no execute command found in $config_file"
-    printf "\n      Please add line \"execute_command ...\" to that file."
-    locat=config_file; exit
- fi
-
- if [[ "$hostfile" != "" ]]
- then
-    if [[ $hostfile != auto  &&  ! -f $hostfile ]]
-    then
-       printf "\n  +++ no hostfile \"$hostfile\" found"
-       printf "\n      Please check line \"hostfile ...\" in $config_file"
-       locat=config_file; exit    
-    fi
- fi
 
 
     # DETERMINE THE CALL STATUS
- if [[ "$return_address" != "" ]]
- then
- 
-       # I AM RUNNING ON A REMOTE HOST, WHICH ALSO MEANS THAT I AM RUNNING IN
-       # BATCH MODE AND ...
-    running_on_remote=true
- 
+ if [[ "$remote_ip" != "" ]]
+ then
+    run_on_remote=true
  else
-
-       # I HAVE BEEN CALLED INTERACTIVELY ON THIS HOST
-     if [[ "$remote_ip" != "" ]]
-     then
-
-           # I HAVE TO CREATE A BATCH JOB TO RUN PALM ON THE REMOTE HOST
-        create_remote_batch_job=true
-
-           # CHECK THAT THE REMOTE JOBCATALOG HAS BEEN SET
-        if [[ "$remote_jobcatalog" = "" ]]
-        then
-           printf "\n  +++ no remote jobcatalog found in $config_file"
-           printf "\n      Please add line \"remote_jobcatalog ...\" to that file."
-           locat=config_file; exit
-        fi
- 
-
-     fi
-     running_on_remote=false
- fi
-
+    run_on_remote=false
+ fi
 
 
     # READ AND EVALUATE THE I/O-FILE LIST
  [[ $silent = false ]]  &&  printf "\n    Reading the I/O files... "
+
 
     # READ THE FILE CONNECTION FILE LINE BY LINE
@@ -673,243 +472,32 @@
 
 
-    # VALUES OF PALMRUN-OPTIONS OVERWRITE THOSE FROM THE CONFIGURATION-FILE
- [[ "$palmrun_memory" != "" ]]  &&  memory=$palmrun_memory
- [[ "$palmrun_cpumax" != "" ]]  &&  cpumax=$palmrun_cpumax
- [[ "$palmrun_cores"  != "" ]]  &&  cores=$palmrun_cores
- [[ "$max_par_io_str" != "" ]]  &&  maximum_parallel_io_streams=$max_par_io_str
- [[ "$palmrun_tasks_per_node" != "" ]]  &&  tasks_per_node=$palmrun_tasks_per_node
-
-
-
-      # EVALUATE MODEL COUPLING FEATURES (OPTION -Y)
- if [[ $run_coupled_model = true ]] 
- then
-
-    cores_atmos=`echo $coupled_dist | cut -d" " -s -f1`
-    cores_ocean=`echo $coupled_dist | cut -d" " -s -f2`
-
-    if (( $cores_ocean + $cores_atmos != $cores ))
-    then
-
-       printf "\n  +++ number of processors does not fit to specification by \"-Y\"."
-       printf "\n      PEs (total)     : $cores"
-       printf "\n      PEs (atmosphere): $cores_atmos"
-       printf "\n      PEs (ocean)     : $cores_ocean"
-       locat=coupling; exit
-
-    fi
-
- fi
-
-
-    # IF I AM IN BATCH MODE, CHECK IF EXECUTABLE AND OTHER REQUIRED FILES
-    # HAVE BEEN GENERATED BY PALMBUILD AND STORED IN THE SOURCES_FOR_RUN_...
-    # FOLDER
- if [[ $running_in_batch_mode = true ]]
+    # VALUES OF INIFOR-OPTIONS OVERWRITE THOSE FROM THE CONFIGURATION-FILE
+    # next line is just an example
+    # TODO: default values for inifor script options could be set in the configuration file
+    #       (if it makes sense)
+ [[ "$inifor_cores"  != "" ]]  &&  cores=$inifor_cores
+
+
+
+    # CHECK IF INIFOR EXECUTABLE EXISTS
+ if [[ $run_on_remote = false ]]
  then
  
-    if [[ ! -d ${fast_io_catalog}/${sources_for_run_catalog} ]]
-    then
-       printf "\n  +++ directory ${fast_io_catalog}/${sources_for_run_catalog} is missing"
-       printf "\n      Please check the output of the palmrun-call"
-       printf "\n      that you did on your local host."
-       locat=SOURCES_FOR_RUN; exit
+    if [[ ! -f ${base_directory}/MAKE_DEPOSITORY_${configuration_identifier}/inifor ]]
+    then
+       printf "\n  +++ no inifor executable found in folder"
+       printf "\n      \"${base_directory}/MAKE_DEPOSITORY_${configuration_identifier}\" "
+       printf "\n      You may run \"palmbuild -c ${configuration_identifier}\" to create"
+       printf "\n      the utility routines."
+       locat=connect; exit
     fi
 
  else
 
-       # CREATE THE SOURCES_FOR_RUN_... FOLDER, BUT NOT IF I AM PART OF AN
-       # AUTOMATIC RESTART RUN
-       # AUTOMATIC RESTART RUNS JUST ACCESS THE DIRECTORY CREATED BY THE INITIAL RUN
-    if [[ $restart_run = false ]]
-    then
-
-          # COLLECT FILES TO BE COMPILED IN THE SOURCES_FOR_RUN_... FOLDER ON
-          # THE LOCAL HOST
-       if [[ ! -d $source_path ]]
-       then
-          printf "\n\n  +++ source path \"$source_path\" on local host"
-          printf "\n      \"$(hostname)\" does not exist"
-          locat=source_path; exit
-       fi
-
-       rm -rf   ${base_directory}/${sources_for_run_catalog}
-       mkdir -p ${base_directory}/${sources_for_run_catalog}
-
-       if [[ "$source_list" = LM ]]
-       then
-
-             # DETERMINE MODIFIED FILES OF THE SVN WORKING COPY
-          source_list=""
-          cd  $source_path
-
-
-             # CHECK, IF TRUNK-DIRECTORY IS UNDER SVN CONTROL
-          if [[ ! -d ../.svn ]]
-          then
-             printf "\n\n  +++ source directory"
-             printf "\n         \"$source_path\" "
-             printf "\n         is not under control of \"subversion\"."
-             printf "\n         Please do not use palmrun-option \"-s LM\"\n"
-          fi
-
-
-             # LIST ALL MODIFIED SOURCE CODE FILES
-          Filenames=""
-          svn status  >  tmp_svnstatus
-          while  read line
-          do
-             firstc=`echo $line | cut -c1`
-             if [[ $firstc = M  ||  $firstc = "?" ]]
-             then
-                Name=`echo "$line" | cut -c8-`
-                extension=`echo $Name | cut -d. -f2`
-                if [[ "$extension" = f90 || "$extension" = F90 || "$extension" = f || "$extension" = F || "$extension" = c ]]
-                then
-                   Filenames="$Filenames "$Name
-                fi
-             fi
-          done < tmp_svnstatus
-          rm -rf  tmp_svnstatus
-
-
-             # COPY FILES TO SOURCES_FOR_RUN_...
-          for  filename  in  $Filenames
-          do
-             cp  $filename  ${base_directory}/${sources_for_run_catalog}
-             source_list=$source_list"$filename "
-          done
-
-          cd -  > /dev/null
-
-
-          # COPY FILES GIVEN BY OPTION -s TO DIRECTORY SOURCES_FOR_RUN_...
-       elif [[ "$source_list" != "" ]]
-       then
-
-          cd  $source_path
-
-          for  filename  in  $source_list
-          do
-
-                # SOURCE CODE FILE IS NOT ALLOWED TO INCLUDE PATH
-             if [[ $(echo $filename | grep -c "/") != 0 ]]
-             then
-                printf "\n  +++ source code file:  $filename"
-                printf "\n      must not contain (\"/\") "
-                locat=source; exit
-             fi
-
-             if [[ ! -f $filename ]]
-             then
-                printf "\n  +++ source code file:  $filename"
-                printf "\n      does not exist"
-                locat=source; exit
-             else
-                cp  $filename  ${base_directory}/${sources_for_run_catalog}
-             fi
-
-          done
-
-          cd -  > /dev/null
-
-       fi
-
-          # CHECK, IF MAKEFILE EXISTS AND COPY IT TO THE SOURCES_FOR_RUN... DIRECTORY
-       [[ "$makefile" = "" ]]  &&  makefile=$source_path/Makefile
-       if [[ ! -f $makefile ]]
-       then
-          printf "\n  +++ file \"$makefile\" does not exist"
-          locat=make; exit
-       else
-          cp  $makefile  ${base_directory}/${sources_for_run_catalog}/Makefile 
-       fi
-
-
-          # COPY FILES FROM OPTIONAL SOURCE PATH GIVEN IN THE CONFIGURATION FILE
-       if [[ "$user_source_path" != "" ]]
-       then
-
-             # DOES THE DIRECTORY EXIST?
-          if [[ ! -d $user_source_path ]]
-          then
-
-             printf "\n\n  *** INFORMATIVE: additional source code directory"
-             printf "\n      \"$user_source_path\" "
-             printf "\n      does not exist or is not a directory."
-             printf "\n      No source code will be used from this directory!\n"
-             user_source_path=""
-             if [[ $silent == false ]]
-             then
-                sleep 2
-             fi
-
-          else
-
-             cd $user_source_path
-
-             Names=$(ls -1 *.f90 2>&1)
-             [[ $(echo $Names | grep -c '*.f90') = 0 ]]  &&  AddFilenames="$Names"
-             Names=$(ls -1 *.F90 2>&1)
-             [[ $(echo $Names | grep -c '*.F90') = 0 ]]  &&  AddFilenames="$AddFilenames $Names"
-             Names=$(ls -1 *.F 2>&1)
-             [[ $(echo $Names | grep -c '*.F') = 0   ]]  &&  AddFilenames="$AddFilenames $Names"
-             Names=$(ls -1 *.f 2>&1)
-             [[ $(echo $Names | grep -c '*.f') = 0   ]]  &&  AddFilenames="$AddFilenames $Names"
-             Names=$(ls -1 *.c 2>&1)
-             [[ $(echo $Names | grep -c '*.c') = 0   ]]  &&  AddFilenames="$AddFilenames $Names"
-
-             cd -  > /dev/null
-             cd  ${base_directory}/${sources_for_run_catalog}
-
-                # COPY MAKEFILE IF EXISTING
-             if [[ -f $user_source_path/Makefile ]]
-             then
-                printf "\n\n  *** user Makefile from directory"
-                printf "\n      \"$user_source_path\" is used \n"
-                if [[ $silent == false ]]
-                then
-                   sleep 1
-                fi
-                cp  $user_source_path/Makefile  .
-             fi
-
-             for  filename  in  $AddFilenames
-             do
-                if [[ -f $filename ]]
-                then
-                   printf "\n  +++ source code file \"$filename\" found in additional"
-                   printf "\n      source code directory \"$user_source_path\" "
-                   printf "\n      but was also given with option \"-s\" which means that it should be taken"
-                   printf "\n      from directory \"$source_path\"."
-                   locat=source; exit
-                fi
-
-                cp  $user_source_path/$filename  .
-                source_list="$source_list $filename"
-
-                   # CHECK IF FILE IS CONTAINED IN MAKEFILE
-                if [[ $(grep -c $filename Makefile) = 0 ]]
-                then
-                   printf "\n\n  +++ user file \"$filename\" "
-                   printf "\n      is not listed in Makefile \n"
-                   locat=source; exit
-                fi
-             done
-             cd -  > /dev/null
-          fi
-       fi
-
-          # COPY CONFIGURATION FILES
-       cp  $config_file  ${base_directory}/${sources_for_run_catalog}
-       cp  $fileconnection_file  ${base_directory}/${sources_for_run_catalog}
-
-          # COPY SHELLSCRIPTS
-       cp  ${source_path}/../SCRIPTS/palmrun    ${base_directory}/${sources_for_run_catalog}
-       cp  ${source_path}/../SCRIPTS/batch_scp  ${base_directory}/${sources_for_run_catalog}
-
-    fi
-
- fi
+    printf "\n  +++ remote call of inifor not realized yet"
+    locat=inifor_remote; exit
+
+ fi
+
 
 
@@ -923,56 +511,4 @@
 
 
-    # IN CASE OF PARALLEL EXECUTION, CHECK SOME SPECIFICATIONS CONCERNING PROCESSOR NUMBERS
- if [[ -n $cores ]]
- then
-
-       # CHECK, IF THE NUMBER OF CORES PER NODE HAS BEEN GIVEN UND IF IT IS AN
-       # INTEGRAL DIVISOR OF THE TOTAL NUMBER OF CORES GIVEN BY OPTION -X
-    if [[ $tasks_per_node = 0 ]]
-    then
-       if [[ $create_batch_job = true  ||  $create_remote_batch_job = true ]]
-       then
-          printf "\n"
-          printf "\n  +++ option \"-T\" (tasks per node) is missing"
-          printf "\n      set -T option or define tasks_per_node in the config file"
-          locat=tasks_per_node; (( iec = 0 )); exit
-       else
-             # DEFAULT FOR INTERACTIVE RUN
-          tasks_per_node=$cores
-       fi
-    fi
-
-    if (( cores < tasks_per_node ))
-    then
-       printf "\n"
-       printf "\n  +++ tasks per node (-T) cannot exceed total number of cores (-X)"
-       printf "\n      given values: -T $tasks_per_node  -X $cores"
-       locat=tasks_per_node; (( iec = 0 )); exit 
-    fi
-
-    (( nodes = cores / ( tasks_per_node * threads_per_task ) ))
-    (( mpi_tasks = cores / threads_per_task ))
-    [[ $mpi_tasks = 0 ]]  &&  (( mpi_tasks = 1 ))
-    (( ii = cores / tasks_per_node ))
-    (( remaining_cores =  cores - ii * tasks_per_node ))
-    if (( remaining_cores > 0 ))
-    then
-       printf "\n"
-       printf "\n  +++ WARNING: tasks per node (option \"-T\") is not an integral"
-       printf "\n      divisor of the total number of cores (option \"-X\")"
-       printf "\n      values of this palmrun-call: \"-T $tasks_per_node\" \"-X $cores\""
-       printf "\n      One of the nodes is filled with $remaining_cores instead of $tasks_per_node tasks"
-       (( nodes = nodes + 1 ))
-    fi
-
- fi
-
-
-    # SET DEFAULT VALUE FOR THE MAXIMUM NUMBER OF PARALLEL IO STREAMS
- if [[ "$maximum_parallel_io_streams" = "" ]]
- then
-    maximum_parallel_io_streams=$cores
- fi
-
 
     # SET PORT NUMBER OPTION FOR CALLS OF SSH/SCP AND batch_scp SCRIPT
@@ -989,23 +525,4 @@
  then
     ssh_key="-i $HOME/.ssh/$ssh_key"
- fi
-
-
-    # SET QUEUE, IF NOT GIVEN
- if [[ $create_batch_job = true  ||  $create_remote_batch_job = true ]]
- then
-
-    if [[ $queue = none  &&  "$defaultqueue" = "" ]]
-    then
-       printf "\n"
-       printf "\n  +++ no default queue given in configuration file and no queue"
-       printf "\n      given with option -q"
-       locat=queue; exit
-    fi
-    if [[ $queue = none ]]
-    then
-       queue=$defaultqueue
-    fi
-
  fi
 
@@ -1315,96 +832,13 @@
 
 
-    # DETERMINE THE NAME OF PALMRUN'S TEMPORARY WORKING DIRECTORY
- if [[ $running_in_batch_mode = false ]]
- then
-    run_id_number=$RANDOM
-    run_id=${run_identifier}.$run_id_number
-
-    tempdir=$fast_io_catalog/$run_id
-
-       # FOR COMPATIBILITY REASONS WITH OLDER VERSIONS SET JOB_ID
-    export job_id=$run_id
-
- fi
-
-
-    # CHECK SETTINGS REQUIRED FOR BATCH JOBS
- if [[ $create_batch_job = true  ||  $create_remote_batch_job = true ]]
- then
-
-       # CHECK, IF JOB DIRECTIVES HAVE BEEN GIVEN IN CONFIGURATION FILE
-    if [[ $ibd = 0 ]]
-    then
-       printf "\n"
-       printf "\n  +++ no batch directives found in configuration file"
-       locat=config_file_batch_directives; (( iec = 0 )); exit 
-    fi
-
-       # CHECK IF CPUTIME IS GIVEN FOR JOB
-    done=false
-    cputime=$cpumax
-    while [[ $done = false ]]
-    do
-       if (( cputime == 0 ))
-       then
-          printf "\n  +++ cpu-time is undefined"
-          printf "\n  >>> Please type CPU-time in seconds as INTEGER:"
-          printf "\n  >>> "
-          read  cputime   1>/dev/null  2>&1
-       else
-          done=true
-       fi
-    done
-    cpumax=$cputime
-
-       # CHECK THE MEMORY DEMAND
-    done=false
-    while [[ $done = false ]]
-    do
-       if (( memory == 0 ))
-       then
-          printf "\n  +++ memory demand is undefined"
-          printf "\n  >>> Please type memory in  MByte per process  as INTEGER:"
-          printf "\n  >>> "
-          read  memory  1>/dev/null  2>&1
-       else
-          done=true
-       fi
-    done
-
-       # IN CASE OF REMOTE-JOBS CHECK, IF A USERNAME FOR THE REMOTE HOST IS GIVEN
-    if [[ $create_remote_batch_job = true  &&  -z $remote_username ]]
-    then
-       while [[ -z $remote_username ]]
-       do
-          printf "\n  +++ username on remote host with IP \"$remote_ip\" is undefined"
-          printf "\n  >>> Please type username:"
-          printf "\n  >>> "
-          read  remote_username
-       done
-    fi
-
- else
-
-    if [[ $running_in_batch_mode = false ]]
-    then
-       cputime=10000000  # NO LIMT FOR INTERACTIVE RUNS
-       cpumax=$cputime
-    else
-       cputime=$cpumax
-    fi
-
- fi
-
-
-    # CALCULATE HOURS/MINUTES/SECONDS, E.G. FOR BATCH-DIRECTIVES
- (( cpu_hours  = cputime / 3600 ))
- (( resttime = cputime - cpu_hours * 3600 ))
- (( cpu_minutes  = resttime / 60 ))
- (( cpu_seconds = resttime - cpu_minutes * 60 ))
- timestring=${cpu_hours}:${cpu_minutes}:${cpu_seconds}
-
-
-    # OUTPUT OF THE PALMRUN-HEADER
+    # DETERMINE THE NAME OF INIFOR'S TEMPORARY WORKING DIRECTORY
+ run_id_number=$RANDOM
+ run_id=${run_identifier}.$run_id_number
+ tempdir=$fast_io_catalog/$run_id
+
+
+
+
+    # OUTPUT OF THE INIFOR-HEADER
  calltime=$(date)
  printf "\n"
